''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    IBM Tivoli Monitoring
'    Decision Tree script
'
'    This file has been generated by IBM Tivoli Monitoring Resource Model Builder
'
'    <<DATE>>

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' GLOBAL CONSTANTS

' TRACE Constants to be used by Svc.Trace() calls
Const TRACE_ERROR  As Integer = 0
Const TRACE_FINE   As Integer = 1
Const TRACE_FINER  As Integer = 2
Const TRACE_FINEST As Integer = 3

' This variable can be used in your Svc.Trace calls to make it easier to
' search through the log file and find calls made by your resource models.
Const TRACE_SOURCE As String = "RM TRACE: "

' RETURN CODE constants for various error conditions
Const RC_INVALID_RESOURCE_TYPE As Integer = 801
Const RC_RESOURCE_UNAVAILABLE  As Integer = 405
Const RC_INVALID_METRIC        As Integer = 406
Const RC_INVALID_VERSION       As Integer = 802
Const RC_COLLECTION_ERROR      As Integer = 407

' end of GLOBAL CONSTANTS declarations

<<GLOBAL_CODE>>

' This subroutine implements the Resource Model Engine for Windows monitoring algorithm.
' This subroutine is used for debugging the new resource model within the Workbench (or any other VB IDE).
' Remember that this subroutine will never be called by the Resource Model Engine for Windows.
' Please, do not modify it.
Public Sub Main()

	' Creating an instance of the TMWService Object...
	Dim TMWService As Object
	Set TMWService = CreateObject("TMWService.Utilities")

	Dim RetVal As Long

	' Calling the SetDefaultConfiguration (...) function to configure the Resource Model.
	RetVal = SetDefaultConfiguration (TMWService)

	If (RetVal = 0) Then

		' Calling Init (...).
		RetVal = Init (TMWService)

		If (RetVal = 0) Then

			' Entering the monitoring loop...
			' It will loop forever.
			Do While (RetVal = 0)

				' Collect Data
				On Error GoTo CATCH_ERROR
				TMWService.CollectData
				GoTo NORMAL_FLOW
CATCH_ERROR:
				MsgBox ("Error occurred in CollectData." & "The hex error code is: " & Hex(Err.Number))
				TMWService.Trace(0, "Error occurred in CollectData." & "The hex error code is: " & Hex(Err.Number))
				TMWService.Dispose()
				Exit Sub
NORMAL_FLOW:

				' Visit the decision tree
				RetVal = VisitTree(TMWService)

				If (RetVal = 0) Then

					' Wait for a cycle time
					TMWService.EndVisit
					Wait TMWService.GetCycleTime()

				End If 'VisitTree = 0

			Loop

		End If 'Init = 0

	End If 'SetDefaultConfiguration = 0

	' Clean up used resources
	TMWService.Dispose

End Sub


' This function is used to define the settings of the resource model.
' It is called only once, when the resource model is started.
' Do not modify remarks containing tags like <<....>> ... <<\...>>.
' You can write additional initializing code at the end of this function if required.
Public Function SetDefaultConfiguration (Svc As Object) As Long

	Svc.Trace(TRACE_FINEST, TRACE_SOURCE + "SetDefaultConfiguration entered")

	' General info section
	'<<GENERAL_INFO>>
	'<<\GENERAL_INFO>>

	' Thresholds section
	'<<THRESHOLDS_INFO>>
	'<<\THRESHOLDS_INFO>>

	' Parameters section
	'<<PARAMETERS_INFO>>
	'<<\PARAMETERS_INFO>>

	' Dynamic model section
	'<<DATA_INFO>>
	'<<\DATA_INFO>>

	' Event definition section
	'<<EVENTS_INFO>>
	'<<\EVENTS_INFO>>

	' Logging definition section
	'<<LOGGING_INFO>>
	'<<\LOGGING_INFO>>

	' Place your additional intializing code below

	Svc.Trace(TRACE_FINEST, TRACE_SOURCE + "SetDefaultConfiguration exited")
	SetDefaultConfiguration = 0

End Function


' This function is called by the DM For Windows Analyzer after that
' the resource model default settings have been overridden
' It is called only once, when the resource model is started.
' You can write additional initializing code in this function if required
' to use the thresholds and parameters values
Public Function Init(Svc As Object) As Long
	
	Svc.Trace(TRACE_FINEST, TRACE_SOURCE + "Init entered")

<<INIT_CODE>>

End Function



' This function contains the monitoring algorithm
' It is called cyclically after a cycle time has elapsed
' Implement the monitoring code here
Public Function VisitTree(Svc As Object) As Long

<<VISIT_TREE_CODE>>
End Function


